jumping = PlayerCanJump()
function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

hifi = GetQualityLevel() > 2 -- GetQualityLevel returns 1,2,or 3
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end

quality = GetQualityLevel4()
function ByQuality4(low,med,high,ultra)
	if quality < 2 then return low
	elseif quality <3 then return med
	elseif quality <4 then return high
	else return ultra end
end

skinvars = GetSkinProperties()
trackWidth = skinvars["trackwidth"]
--trackWidth = fif(jumping, 11.5, 7)
ispuzzle = skinvars.colorcount>1
fullsteep = jumping or skinvars.prefersteep or (not ispuzzle)

SetScene{
	glowpasses = ifhifi(4,0),
	glowspread = ifhifi(0.75,0),
	radialblur_strength = ifhifi(.75,0), -- foreground radial blur
--	radialblur_strength = fif(jumping,2,0),
	--environment = "city",
	watertype = 2,
	water = jumping, --only use the water cubes in wakeboard mode
	watertint = {r=255,g=255,b=255,a=234},
	watertexture = "WaterCubesBlue_BlackTop_WhiteLowerTier.png",--texture used to color the dynamic "digital water" surface
	towropes = jumping,--use the tow ropes if jumping
	airdebris_count = ifhifi(3000,500),
	airdebris_density = ifhifi(50,10),
	airdebris_texture = "firework64.png",

--	airdebris_count = ifhifi(fif(jumping, 80000, 100000),1000),
--	airdebris_density = ifhifi(100,2),
--	airdebris_particlesize = fif(jumping, 0.12, 0.09),
--	airdebris_fieldsize = 300,
--	airdebris_layer = 13,

	useblackgrid=false,
	twistmode={curvescaler=1, steepscaler=fif(fullsteep,1,.65)} -- note: "cork" is the same as {curvescaler=1, steepscaler=1} and "cork_flatish" is the same as {curvescaler=1, steepscaler=.4}
}

SetBlockFlashes{
	texture="hit2.jpg"
}

--pixel style...
--if quality>3 then -- move LED effect to Ultra only
if hifi then -- move LED effect to Ultra only
	radialBlurEffect = BuildMaterial{ -- background radial blur (seen mostly on star air debris trails)
		shader="PostRadialBlur",
		shadersettings={_Amount=.096, _Center={.5,.5,0}}
	}

	AddPostEffect{
		depth="background",
		material = radialBlurEffect
	}


--	pixelateEffectB = BuildMaterial{
--		shader="PostPixelate",
--		shadersettings={_Scale=6}
--	}
--
--	AddPostEffect{
--		depth="background", -- "foreground"
--		material = pixelateEffectB
--	}

	pixelateEffect = BuildMaterial{
		shader="PostLed",
		shadersettings={_Scale=5}
	}

	AddPostEffect{
		depth="background",
		material = pixelateEffect
	}

--	pixelateEffect = BuildMaterial{ -- this looks like a bug to players :(
--		shader="PostPixelateAlphaBlack",
--		shadersettings={_Scale=4}
--	}
--
--	AddPostEffect{
--		depth="topmost_exclusive", -- "topmost_exclusive" means only layers 14 and 15 will be included in this effect. 
--		material = pixelateEffect
--	}

	pixelateEffect = BuildMaterial{ -- this looks like a bug to players :(
		shader="PostLedAlpha",
		shadersettings={_Scale=4}
	}

	AddPostEffect{
		depth="topmost_exclusive", -- "topmost_exclusive" means only layers 14 and 15 will be included in this effect. 
		material = pixelateEffect
	}
end

-- ...or lightbright style
--if hifi then
--	pixelateEffect = BuildMaterial{
--		shader="PostLed",
--		shadersettings={_Scale=5}
--	}
--
--	AddPostEffect{
--		depth="background",
--		material = pixelateEffect
--	}
--end

if not jumping then
squareMesh = BuildMesh{
				recalculateNormalsEveryFrame=true,
				--splitVertices = true,
				--barycentricTangents = true,
				meshes={"squaremorph_baseline.obj", "squaremorph0.obj", "squaremorph1.obj", "squaremorph2.obj", "squaremorph3.obj", "squaremorph4.obj"}
			}


	SetBlocks{
		maxvisiblecount = fif(hifi,200,50),
		allow_mod_block_scaling = false,
		colorblocks={
			--mesh = "SingleLozenge.obj",
			mesh = "NewBlock.obj",
			reflect = true,
			--shader = fif(ispuzzle, "Diffuse", "Rim Light"),
			--shader = fif(ispuzzle, "Diffuse", "VertexColorUnlitTinted"),
			shader = fif(ispuzzle, "UnlitEdgedBlock", "UnlitEdgedBlock"),
			shadersettings={_Brightness=1.42},
			texture = "NewBlock.png",
		    height = 0,
		    float_on_water = false,
		    scale = {1,1,1}
		},
		greyblocks={
			--mesh = "singlespike.obj",
			mesh = "NewBlock.obj",
			reflect = true,
			shader = "VertexColorUnlitTinted",
			shadersettings={_Brightness=1.42},
			texture = "NewBlock2.png"
			--shader = "VertexColorUnlitTinted",
			--texture = "doublespike.png"
		},
		powerups={--override the following objects in case the mod uses them
			powerpellet={
				--mesh = squareMesh,
				mesh = "PowerStar.obj",
				--shader = fif(hifi,"MatCap/Vertex/Textured Lit Double", "MatCap/Vertex/PlainBright"),
				shader = fif(ispuzzle, "UnlitEdgedBlock", "UnlitEdgedBlock"),
				--shadersettings = fif(hifi, {_Brightness=3.0}, {_Brightness=5}),
				shadersettings={_Brightness=1.42},
				--textures = {_MainTex="White.png", _MatCap="matcapchrome.jpg"},
				texture = "NewBlock.png",
				scale = {1,1,1},
				--scale = {2.7,2.7,2.7},
				shadercolors = {_Color="highway", scaletype="intensity", minscaler=2, maxscaler=2.5},
				reflect = true
			}
		}
	}
end

SetPuzzleGraphics{
	usesublayerclone = false,
	puzzlematchmaterial = {shader="Unlit/Transparent",texture="tileMatchingBars.png",aniso=9},
	puzzleflyupmaterial = {shader="VertexColorUnlitTintedAddFlyup",texture="tileMatchingBars2.png"},
	puzzlematerial = {shader="VertexColorUnlitTintedAlpha",texture="tilesSquare.png",texturewrap="clamp",aniso=9, usemipmaps="false",shadercolors={_Color={255,255,255,255}}}
}

if jumping then
	SetPlayer{
		--showsurfer = true,
		--showboard = true,
		cameramode = "first_jumpthird",
		--cameramode_air = "third",--"first_jumptrickthird", --start in first, go to third for jumps and tricks

		camfirst={ --sets the camera position when in first person mode. Can change this while the game is running.
			pos={0,2.7,-3.50475},
			rot={20.49113,0,0},
			strafefactor = 1
		},
		camthird={ --sets the two camera positions for 3rd person mode. lerps out towards pos2 when the song is less intense
			pos={0,2.7,-3.50475},
			rot={20.49113,0,0},
			strafefactor = 0.75,
			pos2={0,2.8,-3.50475},
			rot2={20.49113,0,0},
			strafefactorFar = 1},
		surfer={ --set all the models used to represent the surfer
			arms={
				--mesh="arm.obj",
				shader="RimLightHatchedSurfer",
				shadercolors={
					_Color={colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=6, param="_Threshold", paramMin=2, paramMax=2},
					_RimColor={0,63,192}
				},
				texture="FullLeftArm_1024_wAO.png"
			},
			board={
				--mesh="wakeboard.obj",
				shader=ifhifi("RimLightHatchedSurferExternal","VertexColorUnlitTinted"), -- don't use the transparency shader in lofi mode. less fillrate needed that way
				renderqueue=3999,
				shadercolors={ --each color in the shader can be set to a static color, or change every frame like the arm model above
					_Color={colorsource="highway", scaletype="intensity", minscaler=5, maxscaler=5},
					_RimColor={0,0,0}
				},
				shadersettings={
					_Threshold=11
				},
				texture="board_internalOutline.png"
			},
			body={
				--mesh="surferbot.obj",
				shader="RimLightHatchedSurferExternal", -- don't use the transparency shader in lofi mode. less fillrate needed that way
				renderqueue=3000,
				layer = 14,
				shadercolors={
					_Color={colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=3},
					_RimColor={0,0,0}
				},
				shadersettings={
					_Threshold=1.7
				},
				texture="robot_HighContrast.png"
			}
		}
	}
else
	SetPlayer{
		cameramode = "third",
		cameradynamics = "high",

		camfirst={
			pos={0,1.84,-0.8},
			rot={20,0,0}},
		camthird={
			--pos={0,2.1,-0.5},
			--pos={0,2,-0.5},
			pos={0,2.5,-1},
			rot={30,0,0},
			strafefactor = .5,
			strafefactorFar = .75,
			pos2={0,5,-4},
			--pos2={0,2.5,-1},
			rot2={30,0,0},
			--strafefactorFar = 1,
			--transitionspeed = 3,
			transitionspeed = 3,
			puzzleoffset=-0.95,
			puzzleoffset2=-1.5},
		vehicle={ --livecoding not supported here
			min_hover_height= 0.05,
			max_hover_height = 0.9,
			use_water_rooster = false,
            smooth_tilting = false,
            smooth_tilting_speed = 10,
            smooth_tilting_max_offset = -20,
			pos={x=0,y=0,z=0},
			mesh="ninjamono.obj",
			--shader="VertexColorUnlitTintedPixelate",
			shader="Rim Light Pixelate",
			--layer = ifhifi(14,15), -- in hifif mode, render it to the topmost only. so the non-pixelated parts don't show through
			layer = 15,
			reflect = true,
			renderqueue = 2000,
			shadersettings={_Scale=8, _Brightness=1.5},
			shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5},
				_RimColor = {43,43,43}},
			texture="ninjamono.png",
			scale = {x=1,y=1,z=1},
			thrusters = {crossSectionShape={{-.35,-.35,0},{-.5,0,0},{-.35,.35,0},{0,.5,0},{.35,.35,0},{.5,0,0},{.35,-.35,0}},
						perShapeNodeColorScalers={.5,1,1,1,1,1,.5},
						--shader="VertexColorUnlitTinted",
						shader="VertexColorUnlitTintedAddSmooth",
						layer = 14,
						renderqueue = 2999,
						colorscaler = 2,
						extrusions=22,
						stretch=-0.1191,
						updateseconds = 0.025,
						instances={
							{pos={0,.46,-1.28},rot={0,0,0},scale={.7,.7,.7}},
							{pos={.175,0.21,-1.297},rot={0,0,58.713},scale={.7,.7,.7}},
							{pos={-.175,0.21,-1.297},rot={0,0,313.7366},scale={.7,.7,.7}}
						}}
		}
	}
end

--if hifi then
--	SetSkybox{
--		skyscreen = "Skyscreen/TheGrid"
--	}
--else
	SetSkybox{ --this shows how to set up a skybox. There's also a dynamic sky system that's used by the audiosprint skin. It could be used here too.
		skysphere="skyline.jpg"
	}
--end

SetTrackColors{ --enter any number of colors here. The track will use the first ones on less intense sections and interpolate all the way to the last one on the most intense sections of the track
    {r=214, g=0, b=254},
    {r=0, g=176, b=255},
    {r=0, g=184, b=0},
    {r=255, g=255, b=0},
	{r=255, g=0, b=0}
}

if skinvars.colorcount < 5 then
	SetBlockColors{
	    {r=0, g=176, b=255},
	    {r=0, g=184, b=0},
	    {r=255, g=255, b=0},
		{r=255, g=0, b=0}
	}
else
	SetBlockColors{
	    {r=214, g=0, b=254},
	    {r=0, g=176, b=255},
	    {r=0, g=184, b=0},
	    {r=255, g=255, b=0},
		{r=255, g=0, b=0}
	}
end

--SetBlockColors{ --this is only used for puzzle modes (which you don't have yet) with multiple colors of blocks
--    {r=93, g=8, b=132},
--	{r=1.0, g=0.27, b=0.2},
--    {r=0.047, g=0.5098, b=0.94},
--    {r=1.0, g=0.85, b=0.4157},
--	{r=0, g=0.29, b=0.08},
--    {r=1,g=0,b=0}
--}

--if ispuzzle then
--	CreateLight{
--		type= "directional",
--		railoffset = -1,
--		range = 10,
--		intensity = 1,
--		transform = {
--			position={0,2,0}, rotation={.4,346.2,0}
--		},
--		color={255,255,255}
--	}
--end

SetRings{ --setup the tracks tunnel rings. the airtexture is the tunnel used when you're up in a jump
	texture = ByQuality4("Classic_OnBlack_256.png", "Classic_OnBlack_512.png", "Classic_OnBlack_1024.png", "Classic_OnBlack_1024.png"),
	--texture="Classic_OnBlack",
	--shader="VertexColorUnlitTintedAddSmooth",
	shader = "VertexColorUnlitTintedAddDouble",
	layer = 13, -- on layer13, these objects won't be part of the glow effect
	size=fif(jumping, trackWidth*2, trackWidth*1.5), --22
	offset = fif(jumping, {0,0,0}, {0,1,0}),
	percentringed=.2,--ifhifi(2,.01),-- .2,
	airtexture="Bits.png",
	airshader="VertexColorUnlitTintedAddSmoothNoDepth",
	airsize=16
}

--wakeHeight = 2
--if jumping then wakeHeight=2 else wakeHeight = 0 end
--SetWake{ --setup the spray coming from the two pulling "boats"
--	height = wakeHeight,
--	fallrate = 0.95,
--	shader = "VertexColorUnlitTinted",
--	layer = 13, -- looks better not rendered in background when water surface is not type 2
--	bottomcolor = {r=0,g=0,b=100},
--	topcolor = "highway"
--}

wakeHeight = 2
if jumping then wakeHeight=2 else wakeHeight = 0 end
SetWake{ --setup the spray coming from the two pulling "boats"
	height = wakeHeight,
	fallrate = .999,
	shader = "VertexColorUnlitTintedAddSmooth",
	layer = 13, -- looks better not rendered in background when water surface is not type 2
	bottomcolor = "highway",
	topcolor = {r=0,g=0,b=0}
}

CreateObject{
	name="EndCookie",
	tracknode="end",
	gameobject={
		transform={pos={0,0,126},scale={scaletype="intensity",min={55,99,900},max={66,120,900}}},
		mesh="danishCookie_boxes.obj",
		shader="RimLightHatched",
		shadercolors={
			_Color={0,0,0},
			_RimColor={1,1,1}
		}
	}
}

CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="BuildingCloneMe",
	gameobject={
		pos={x=0,y=0,z=0},
		--mesh="skyscraper42.obj",
		mesh="skyscraper_withbase.obj",
		--shader="VertexColorUnlitTintedAlpha",
		shader=fif(jumping, "Diffuse", "VertexColorUnlitTinted"),
		diffuseinair = true,
		shadercolors={
			--_Color={r=255,g=255,b=255}
			--_Color="highwaysmooth"
			--_Color = {colorsource="highway", scaletype="intensity", minscaler=6, maxscaler=6}
			_Color = {colorsource="highway", scaletype="intensity", minscaler=2, maxscaler=2}
		},
		texture=fif(jumping, "White.png", "grey11.jpg"),
		--texture="skyscraper.png",
		scale = {x=1,y=1,z=1}
	}
}

track = GetTrack()--get the track data from the game engine

if buildingNodes == nil then
	buildingNodes = {} --the track is made of nodes, each one with a position and rotation. This table will hold the indices of track nods that should have a skyscraper rendered at them (with some offset)
	offsets = {}
	buildingNodesToo = {}
	offsetsToo = {}
	for i=1,#track do
		if i%250==0 then
			buildingNodes[#buildingNodes+1] = i
			local xOffset = 150 + 1650*math.random()
			if math.random() > 0.5 then xOffset = xOffset * -1 end
			offsets[#offsets+1] = {xOffset,-100,0}
		end

--		if (i+40)%120==0 then
--			buildingNodesToo[#buildingNodesToo+1] = i
--			local xOffset = 150 + 1650*math.random()
--			if math.random() > 0.5 then xOffset = xOffset * -1 end
--			offsetsToo[#offsetsToo+1] = {xOffset,-100,0}
--		end
	end

	BatchRenderEveryFrame{prefabName="BuildingCloneMe", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
							locations=buildingNodes,
                    		rotateWithTrack=false,
                    		maxShown=50,
                    		maxDistanceShown=2000,
							offsets=offsets,
							collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
							testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
						}
end

CreateObject{--skywires, the red lines in the sky. A railed object is attached to the track and moves along it with the player.
	railoffset=0,
	floatonwaterwaves = false,
	gameobject={
		name="scriptSkyWires",
		pos={x=0,y=0,z=0},
		mesh="skywires.obj",
		renderqueue=1000,
		--layer=ifhifi(18,13), -- in low detail the background camera (layer 18) is disabled, so move the skywires to the main camera's layer (13)
		layer=13, -- ifhifi(11,13), -- in low detail the background camera (layer 18) is disabled, so move the skywires to the main camera's layer (13)
		shader="VertexColorUnlitTintedSkywire",
		shadercolors={
			_Color={r=200,g=200,b=200}
		},
		texture="White.png",
		scale = {x=1,y=1,z=1},
		lookat = "end"
	}
}

--RAILS. rails are the bulk of the graphics in audiosurf. Each one is a 2D shape extruded down the length of the track.

if not jumping then
	local laneDividers = skinvars["lanedividers"]
	for i=1,#laneDividers do
		CreateRail{ -- lane line
			positionOffset={
				x=laneDividers[i],
				y=0.1},
			crossSectionShape={
				{x=-.07,y=0},
				{x=.07,y=0}},
			perShapeNodeColorScalers={
				1,
				1},
			colorMode="static",
			color = {r=255,g=255,b=255},
			flatten=false,
			nodeskip = 2,
			wrapnodeshape = false,
			shader="VertexColorUnlitTinted"
		}
	end
end

CreateRail{--big cliff
	positionOffset={
		x=0,
		y=0},
	crossSectionShape={
		{x=11,y=-2},
		{x=22,y=-11},
		{x=22,y=-40},
		{x=-22,y=-40},
		{x=-22,y=-11},
		{x=-11,y=-2}
		},
	perShapeNodeColorScalers={
		1,
		1,
		.4,
		.4,
		1,
		1},
	colorMode="highway",
	color = {r=255,g=255,b=255},
	flatten=false,
	wrapnodeshape = true,
	renderqueue = 1999,
	texture="cliffRails.png",
	fullfuture = true,--ifhifi(true,false),
	stretch = 1,
	calculatenormals = true,
	shader="Cliff"
}


CreateRail{--big cliff Distant, stretched copy
	positionOffset={
		x=0,
		y=0},
	crossSectionShape={
		{x=9,y=-4},
		{x=20,y=-13},
		{x=20,y=-38},
		{x=-20,y=-38},
		{x=-20,y=-13},
		{x=-9,y=-4}
		},
	perShapeNodeColorScalers={
		1,
		1,
		.4,
		.4,
		1,
		1},
	colorMode="highway",
	color = {r=255,g=255,b=255},
	flatten=false,
	wrapnodeshape = true,
	texture="cliffRails.png",
	fullfuture = true,--ifhifi(true,false),
	stretch = 6,
	calculatenormals = true,
	shader="Cliff"
}


if not jumping then
	CreateRail{--road surface
		positionOffset={
			x=0,
			y=0},
		crossSectionShape={
			{x=-trackWidth,y=0},
			{x=trackWidth,y=0}},
		perShapeNodeColorScalers={
			1,
			1},
		colorMode="static",
		color = {r=0,g=0,b=0,a=225},
		--renderqueue=3000,
		renderqueue = 2001,
		flatten=false,
		--texture="cliffRails.png",
		shader="VertexColorUnlitTintedAlpha"
	}
end

CreateRail{--left rail
	positionOffset={
		x=-trackWidth - .2,
		y=0},
	crossSectionShape={
		{x=-.65,y=0.5},
		{x=.3,y=0.5},
		{x=.3,y=-3},
		{x=-.65,y=-3}},
	perShapeNodeColorScalers={
		.5,
		1,
		0,
		0},
	colorMode="highway",
	color = {r=255,g=255,b=255},
	flatten=false,
	--texture="cliffRails.png",
	shader="ProximityEmissionVertexColor",
	shadercolors={_Color={r=0,g=0,b=0}},
	shadersettings={_StartDistance=3.92, _FullDistance=11.9}
}

CreateRail{--right rail
	positionOffset={
		x=trackWidth + .2,
		y=0},
	crossSectionShape={
		{x=-.65,y=0.5},
		{x=.3,y=0.5},
		{x=.3,y=-3},
		{x=-.65,y=-3}},
	perShapeNodeColorScalers={
		.5,
		1,
		0,
		0},
	colorMode="highway",
	color = {r=255,g=255,b=255},
	flatten=false,
	--texture="cliffRails.png",
	shader="ProximityEmissionVertexColor",
	shadercolors={_Color={r=0,g=0,b=0}},
	shadersettings={_StartDistance=3.92, _FullDistance=11.9}
}

CreateRail{--left rail edge
	positionOffset={
		x=-trackWidth - .2,
		y=0},
	crossSectionShape={
		{x=.28,y=0.51},
		{x=.31,y=0.51},
		{x=.31,y=0.48}},
	colorMode="static",
	color = {r=255,g=255,b=255},
	flatten=false,
	--texture="cliffRails.png",
	shader="VertexColorUnlitTinted",
	shadercolors={_Color={r=0,g=0,b=0}}
}

CreateRail{--right rail edge
	positionOffset={
		x=trackWidth + .2,
		y=0},
	crossSectionShape={
		{x=-.66,y=0.48},
		{x=-.66,y=0.51},
		{x=-.63,y=0.51}},
	colorMode="static",
	color = {r=255,g=255,b=255},
	flatten=false,
	--texture="cliffRails.png",
	shader="VertexColorUnlitTinted",
	shadercolors={_Color={r=0,g=0,b=0}}
}

if jumping then
	CreateRail{--left aurora core
		positionOffset={
			x=-18,
			y=33},
		crossSectionShape={
			{x=-13,y=.5},
			{x=-9,y=.5},
			{x=-9,y=-.5},
			{x=-13,y=-.5}},
		perShapeNodeColorScalers={
			1,
			1,
			1,
			1},
		colorMode="highway",
		color = {r=255,g=255,b=255},
		flatten=true,
		texture="White.png",
		shader="VertexColorUnlitTinted"
	}

	CreateRail{--right aurora core
		positionOffset={
			x=18,
			y=33},
		crossSectionShape={
			{x=9,y=.5},
			{x=13,y=.5},
			{x=13,y=-.5},
			{x=9,y=-.5}},
		perShapeNodeColorScalers={
			1,
			1,
			1,
			1},
		colorMode="highway",
		color = {r=255,g=255,b=255},
		flatten=true,
		texture="White.png",
		shader="VertexColorUnlitTinted"
	}

	auroraExtent = ifhifi(77, 22)
	CreateRail{--left aurora
		positionOffset={
			x=-18,
			y=33},
		crossSectionShape={
			{x=-auroraExtent,y=.5},
			{x=-11,y=.5},
			{x=-11,y=-.5},
			{x=-auroraExtent,y=-.5}},
		perShapeNodeColorScalers={
			0,
			1,
			1,
			0},
		colorMode="aurora",
		color = {r=255,g=255,b=255},
		flatten=true,
	    layer=13,
		texture="White.png",
		shader="VertexColorUnlitTintedAddSmoothNoCull"
	}

	CreateRail{--right aurora
		positionOffset={
			x=18,
			y=33},
		crossSectionShape={
			{x=11,y=.5},
			{x=auroraExtent,y=.5},
			{x=auroraExtent,y=-.5},
			{x=11,y=-.5}},
		perShapeNodeColorScalers={
			1,
			0,
			0,
			1},
		colorMode="aurora",
		color = {r=255,g=255,b=255},
		flatten=true,
	    layer=13,
		texture="White.png",
		shader="VertexColorUnlitTintedAddSmoothNoCull"
	}
end